﻿/**
 * reflection to bitmap
 * author : cmiscm@gmail.com
 * date : 2008. 08. 25
 * date of final modification : 2008. 08. 25
*/
package 
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.DisplayObject;
	import flash.display.GradientType;
	import flash.display.Sprite;
	import flash.geom.Matrix;
	
	public class Reflection extends Bitmap
	{
		public function Reflection()
		{
			super();
		}
		
		/**
		 * DisplayObject을 받아서 reflection 적용 후 BitmapData 반환
		 * @param mc - bitmap
		 * @param mcW - bitmap width
		 * @param mcH - bitmap height
		 * @param graH - gradation height
		 * @param graY - gradation y position
		 * @param transparent - bitmap transparent
		 * @param color - gradation area color
		 * @param alpha - gradation first alpha
		 * @return 
		 * 
		 */		
		public static function setReflection(mc:DisplayObject, mcW:int, mcH:int, graH:int, graY:int = 0, transparent:Boolean = false, color:int = 0x00000000, alpha:Number = 0.5):BitmapData
		{
			// reflection image
			var refBitmapData:BitmapData = new BitmapData(mcW, graH, transparent, color);
			var refMat:Matrix = new Matrix();
			refMat.translate(0, mcH);
			refMat.d = -1;			
			refBitmapData.draw(mc, refMat);
			var bitRef:Bitmap = new Bitmap(refBitmapData);
			bitRef.y = mcH + graY;
			
			// reflection gradation
			var fillType:String = GradientType.LINEAR;
			var colors:Array = [0x000000, 0x000000];
			var alphas:Array = [alpha, 0];
			var ratios:Array = [0, 255];
			var graMat:Matrix = new Matrix();
			graMat.createGradientBox(mcW, graH, (90/180)*Math.PI, 0, 0);
			var mcGra:Sprite = new Sprite();
			mcGra.graphics.beginGradientFill(fillType, colors, alphas, ratios, graMat);
			mcGra.graphics.drawRect(0, 0, mcW, graH);
			mcGra.graphics.endFill();
			mcGra.y = mcH + graY;
			
			// mc
			var mcBitmapData:BitmapData = new BitmapData(mcW, mcH, transparent, color);
			mcBitmapData.draw(mc);
			var bitMc:Bitmap = new Bitmap(mcBitmapData);
			
			// mask
			mcGra.cacheAsBitmap = bitRef.cacheAsBitmap = true;			
			bitRef.mask = mcGra;
			
			// addChild
			var mcCon:Sprite = new Sprite();
			mcCon.addChild(bitMc);
			mcCon.addChild(bitRef);			
			mcCon.addChild(mcGra);	
			
			// bitmap
			var conBitmapData:BitmapData = new BitmapData(mcW, mcH + graH + graY, transparent, color);		
			conBitmapData.draw(mcCon);			
			//var bitCon:Bitmap = new Bitmap(conBitmapData);
			
			// dispose
			refBitmapData.dispose();
			bitRef = null;
			mcBitmapData.dispose();
			bitMc = null;
			mcGra.graphics.clear();
			mcGra = null;
			
			return conBitmapData;
		}
	}
}